# Copyright(C) 2005 INL
# Written by Jean Gillaux <jean@inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

class Error(ValueError):
    """Base class for exceptions
    """
    pass

class LoopError(Error):
    """Exception raised when a loop is detected in links
    """
    def __init__(self, value):
        self.value = value

    def __str__(self):
        return repr(self.value)

class LinkError(Error):
    """Exception raised when an link to a non-existent source or destination
    """
    def __init__(self, value):
        self.value = value

    def __str__(self):
        return repr(self.value)

