<?php
# Copyright(C) 2007 INL
# Written by Victor Stinner <victor.stinner AT inl.fr>
#
# $Id: page_tree.php 13933 2008-03-28 15:59:53Z haypo $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

# Pages with sub-menu

global $manage_local_firewall;

$sublinks_pages = array (
    "locals" => Array("localsin", "localsout"),
    "objects" => Array("resources", "protocols"),
);

# Fill $pages_list :
$pages_list = Array("index", "acls");
if ($manage_local_firewall) {
    $pages_list[] = 'locals';
}
$pages_list[] = "nat";
$pages_list[] = "objects";

if ($nufw_firewall){
    $sublinks_pages["objects"] = array_merge($sublinks_pages["objects"], Array("auths", "os", "applications"));
}
if ($l7_firewall) $sublinks_pages["objects"][] = "l7rules";
if ($support_periods) {
	$sublinks_pages["objects"] = array_merge($sublinks_pages["objects"], Array("periodicities", "durations"));
}

# Link to display text correspondance, in each language:
$links2text = Array(
    "index" => _("action"),
    "nat" => _("nat"),
    "acls" => _("acls"),
    "locals" => _("local rules"),
    "objects" => _("objects"),
    "auths" => _("authentication"),
    "protocols" => _("protocols"),
    "resources" => _("resources"),
    "applications" => _("applications"),
    "time" => _("time"),
    "os" => _("operating systems"),
    "periodicities" => _("periodicities"),
    "durations" => _("durations"),
    "l7rules" => _("L7 rules"),
    "localsin" => _("input"),
    "localsout" => _("output"),
);

# Fill $pages_display according to $pages_list
$pages_display = Array();
foreach ($pages_list as $key) {
    if ($key && array_key_exists($key, $links2text)) {
	array_push($pages_display, $links2text[$key]);
    }
}

# Fill $sublinks_display
$sublinks_display = Array();
foreach ($sublinks_pages as $key=>$tab) {
    $sublinks_display[$key] = Array();
    foreach ($tab as $content) {
        array_push($sublinks_display[$key], $links2text[$content]);
    }
}

?>
