<?php
# Copyright(C) 2004-2006 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#            Jean Gillaux <jean@inl.fr>
#            Damien Boucard <damien.boucard AT inl.fr>
#
# $Id: index.php 13805 2008-03-21 11:52:01Z haypo $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

require_once ("include/common.php");
require_once ("include/index_func.php");
require_once ("include/action_menu.php");
require_once ("include/display.php");

$title='index';
$singtitle='index';
$input = getHttp('input_file');
$used_file = getHttp('used_file');
$upload_file = getHttp('upload_file');

if (isset($upload_file) and $upload_file=='up')
{
  uploadUserXML();
}

if ($input)
{
    if (!loadUserXML($input))
    {
        resetSession();
    }
}
else{ #We don't read and write at the same time, do we?
  $output=getHttp('output_file');
  if ($output)
  {
      if (!preg_match('/\.xml$/', $output))
          $output .= '.xml';
      writeUserXML($output);
  }else if (getHttp('xml_download') == 1) {
      writeUserXML('');
  }else if (getHttp('new_ruleset') == 1){
      loadNewRuleset();
  }else{
      // We don't write and delete at the same time, do we?
    $delete=getHttp('delete_file');
    if (isset($delete))
    {
      if(del_file($delete))
      {
        add_log(sprintf(_('The ruleset "%s" was successfully deleted.'), filenameWithoutXml($delete)));
      }else{
        log_error(sprintf(_('An error occured when attempting to delete file "%s".'), "$datadir/$delete"));
      }
    }else{
      if(getHttp('forget') == 1)
      {
          $expolicy = getSession('document');
          if ($expolicy)
          {
              $name = $expolicy->name;
              unset($expolicy);
              resetSession();
              add_log(sprintf(_('The ruleset "%s" is now closed.'), $name));
            }
      } else {
        if (getHttp('generate') == 1)
        {
            firewall_rules($used_file);
        }
      }
    }
  }
}

if (getHttp('generate_desc') == 1) {
    generateDesc();
}

$expolicy = getSession('document');
require_once ("include/headers.php");

actionMenu($expolicy);

if ($expolicy){
    begin_content_detail();
    $expolicy->statistics();
    end_content_detail();
}

require_once ("include/footer.php");
?>

<div class="invisible"><img src="images/rel_interstitial_loading.gif" alt="image preload"></div>
