<?php
require_once('test_common.php');

require_once(NUFACE_DIR . 'include/pear/Net/IPv4.php');

class TestNet_IPv4 extends UnitTestCase {
    function testIpInNetwork() {
        $this->assertTrue(  Net_IPv4::ipInNetwork('127.0.0.1', '127.0.0.0/8') );
        $this->assertFalse(  Net_IPv4::ipInNetwork('192.168.0.1', '127.0.0.0/8') );
    }

    function testIntersect() {
        $this->assertTrue(  Net_IPv4::intersect('127.0.0.1', '127.0.0.1') );
        $this->assertTrue(  Net_IPv4::intersect('192.168.1.0', '192.168.0.0/16') );
        $this->assertFalse( Net_IPv4::intersect('192.168.1.0', '192.168.0.0/24') );
        $this->assertTrue( Net_IPv4::intersect('192.168.1.0', '0.0.0.0/0') );
    }

    function testCompare() {
        $this->assertTrue( Net_IPv4::compare('127.0.0.1', '127.0.0.1') );
        $this->assertTrue( Net_IPv4::compare('192.168.0.0/255.255.0.0', '192.168.0.0/16') );
    }
}

?>
