<?php
# Copyright(C) 2004-2007 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#            Jean Gillaux <jean@inl.fr>
#            Damien Boucard <damien.boucard AT inl.fr>
#
# $Id: function.php 16892 2008-11-19 13:41:03Z haypo $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

require_once('elt.class.php');    # max_elt()

function show_acls_use($expolicy,$type,$id,$mess){
  $used=0;
  foreach (array('acls','localsin','localsout') as $acltype)
  {
          $acls = $expolicy->$acltype;
	  if (isset($acls->elts))
	    $a_type=array();
	    if (is_array($type))
	      $a_type=$type;
	    else
	      array_push($a_type,$type);
	    print "<ul class='aclsuse'>";
	    foreach($a_type as $id_foo => $mytype)
	    {
		    foreach($acls->elts as $acl)
		    {
		      if (isset($acl->$mytype) and ($acl->$mytype == $id))
		      {
		#        print "<div class=\"".$acl->decision."\"><a href=\"acls.php?acl=".$acl->ID."\">".$acl->name."</a></div>\n";
		        print "<li><form action=\"$acltype.php\"><span class=\"".$acl->decision."\">".$acl->name."</span><input type=hidden name=acl value=\"".$acl->ID."\">";
		        print "<input type=image src=\"images/go.png\"></form>\n</li>";
		        $used++;
		      }
		    }
	    }
	    print "</ul>";
  }
  if ($used == 0)
  {
    print "<i>$mess</i>";
  }
}
function show_links_use($expolicy, $type, $id, $mess)
{
  $linkused=0;
  if (isset($expolicy->$type->elts))
  foreach ($expolicy->$type->elts as $this_id=>$object)
  {
    foreach ($object->elts as $sub_id=>$sub_elt)
    {
      if ($sub_elt->datas['type']=='link' and $sub_elt->datas['linkid']==$id)
      {
        print "<ul class='acluse'>";
        print "<li><a href=\"$type.php?elt=".$object->ID."\">".$object->name."</a></li>\n";
        print "</ul>";
        $linkused++;
      }
    }
  }
  if ($linkused == 0)
  {
    print "<i>$mess</i>";
  }
}

function gen_nupyf_args($dir, $dispatch_targets, $default_estrel_invalid, $dispatch, $forward, $input, $output, $nat, $rescue, $mangle)
{
  global $nupyf_same_iface, $debug_nuface, $disable_check_net, $l7_firewall,
    $nupyf_use_ulog, $nufw_firewall, $transparent_proxy_port;

  $args = '';
  if ($debug_nuface)
      $args .= ' --debug';
  if ($rescue == true)
      $args .= ' --rescue';
  if ($dispatch_targets != '')
      $args .= " --dispatch_targets $dir/$dispatch_targets";
  if ($default_estrel_invalid != '')
      $args .= " --default_estrel_invalid $dir/$default_estrel_invalid";
  if ($dispatch != '')
      $args .= " --dispatch $dir/$dispatch";
  if ($forward != '')
      $args .= " --forward $dir/$forward";
  if ($input != '')
      $args .= " --input $dir/$input";
  if ($output != '')
      $args .= " --output $dir/$output";
  if ($nat != '')
      $args .= " --nat $dir/$nat";
  if ($mangle != '')
      $args .= " --mangle $dir/$mangle";
  if ($nupyf_same_iface)
      $args .= " --same-iface";
  if ($disable_check_net)
      $args.= " --no-check-net";
  if ($l7_firewall)
      $args.= " --nulayer7";
  if ($nupyf_use_ulog)
      $args .= " --ulog";
  if ($nufw_firewall)
      $args .= " --nufw";
  $args .= sprintf(" --transparent-proxy-port %s", $transparent_proxy_port);
  return $args;
}

function report_execute($command,&$result)
{
    global $debug_nuface_verbose;
    $command .= ' 2>&1';
    $handle = popen($command,'r');
    $ret = '';
    while(!feof($handle)){
        $ret .= fread($handle,2048);
    }
    $result = pclose($handle);
    if ($debug_nuface_verbose)
        add_log("<b>Execute</b> \"<code>".$command."</code>\", exit code: <b>$result</b><br>");
    return $ret;
}

function init_floatings(&$floating)
{
  global $nufw_firewall;
  global $l7_firewall;
  global $support_periods;
  if (!isset($floating) or ($floating=='' or $floating==array()))
  {
    $floating=array();
    if ($nufw_firewall)
    {
      $init=array('ipv4','nufw','link','proto','app','os');
      if ($support_periods)
        array_push($init,'periodicity','duration');
    }else{
      $init=array('ipv4','link','proto','app');
    }
    if ($l7_firewall)
    {
      array_push($init,'l7rule');
    }
    foreach ($init as $mytype)
    {
        $received = Array(
            'type' => $mytype,
            'name' => '_'.$mytype
        );
        if ($mytype == 'ipv4') {
            $received['net'] = '0.0.0.0';
        } else if ($mytype == 'nufw') {
            $received['group'] = '1';
        }
        $new_elt=new elt($received,'data',max_elt($floating)+1);
        array_push($floating,$new_elt);
    }
  $_SESSION['floating_elts']=serialize($floating);
  }
}

/*
 *   get groups: name and gid
 * $file: path to file to read instead of running getent
 * $sysgroupfile: path to local groups file. groups belonging to this file will not be included
 * in final result
 * return: array gid=>name
*/
function getent_user_groups()
{
    global $groups_file, $sys_groupfile, $decode_groups_from_utf8;

    // If file is set, get group from it instead of getent
    $output = Array();
    if($groups_file){
        $output = file_readlines($groups_file);
    }else{
        exec("getent group", $output, $ret);
    }

    // System group identifiers
    $system_gid = Array();
    if($sys_groupfile != ''){
        // Get groups from /etc/group
        $system_lines = file_readlines($sys_groupfile);
        foreach ($system_lines as $line){
            $line = explode(':', $line, 2);
            $system_gid[] = $line[0];
        }
    }

    $result = array();
    foreach($output as $line){
        // Line syntax is "group_name:x:gid:"
        $line = trim($line);
        if (!$line) {
            continue;
        }
        $line = explode(':',$line,4);
        $name = $line[0];
        $gid = $line[2];

        if (in_array($name, $system_gid)) {
            // Exclude system groups
            continue;
        }
        $result[$gid] = $name;
    }

    // Decode UTF-8 if needed
    if ($decode_groups_from_utf8)
    {
      foreach ($result as $key=>$value)
      {
        $result[$key] = utf8_decode($value);
      }
    }
    return $result;
}


#
# Test if acl has a rule going from or coming to network
# identified by network_id
function acl_touches_network($acl, $direction, $network_id){
    $used_desc = getSession('used_desc', false);
    $desc = $acl->descsorts->get_elt($used_desc);
    if (!$desc) {
        return false;
    }
    foreach ($desc->elts as $id=>$tab){
          if ($direction == 'from' and $tab->from == $network_id){
              return true;
          }
          if ($direction == 'to' and $tab->to == $network_id){
              return true;
          }
    }
    return false;
}

function get_nets($context,$id,$document)
{
  if (($context!='from') and ($context!='to'))
  {
    return array();
  }
  $result=array();
  $object = $document->resources;
  $obj = $object->get_elt_by_id($id);
  {
    if (isset ($obj->elts) and (is_array($obj->elts)))
    {
      foreach (($obj->elts) as $elt_id=>$elt)
      {
        if ($elt->datas['type']=='ipv4')
        {
          array_push($result,$elt->datas['net']);
        }else if ($elt->datas['type']=='link')
        {
          $result = array_merge($result,get_nets($context,$elt->datas['linkid'],$document));
        }else if ($elt->datas['type']=='nufw')
        {
          array_push($result,'all');
        }
      }
    }
  }
  $result=array_unique($result);
  if (count($result)==0)
  {
    array_push($result,'all');
  }
  return($result);
}

function fill_seen_tab($net_array,$descnets)
{
    $result=array();

    foreach($net_array as $id=>$net)
    {
        $seen=0;
        $dftroute=null;

        foreach($descnets as $addr=>$this_desc)
        {
            // Find the default route, used later (search DFTROUTE)
            if ($this_desc->datas['dftroute'] == '1')
            {
                if (isset($this_desc->datas['ID']))
                {
                    $dftroute=$this_desc->datas['ID'];
                }else if (isset($this_desc->datas['id']))
                {
                    $dftroute=$this_desc->datas['id'];
                }
            }
            if ((($this_desc->datas['type']) != 'ipv4') and (($this_desc->datas['type']) != 'mark'))

            {
                continue;
            }
            if ($net!='' and Net_IPv4::ipInNetwork($net, $this_desc->datas['addr']))
            {
                if (isset($this_desc->datas['id'])) {
                    array_push($result, $this_desc->datas['id']);
                } else {
                    array_push($result, $this_desc->datas['ID']);
                }
                $seen = 1;
                break;
            }
        }

        // Not seen, means internet
        if ($seen==0 and !is_null($dftroute))
        {
            array_push($result, $dftroute);
        }
    }
    return $result;
}

# Increment $array[$key] si la clé existe ou alors l'initialise à 0
# Retourne la nouvelle valeur de $array[$key]
function array_increment(&$array, $key)
{
    if (array_key_exists($key, $array))
        $array[$key]++;
    else
        $array[$key] = 0;
    return $array[$key];
}

function array_first($array)
{
    reset($array);
    return current($array);
}

function array_get($array, $key, $default=null)
{
    if (array_key_exists($key, $array))
        return $array[$key];
    else
        return $default;
}

function quote_text($text)
{
    $text = str_replace('\\', '\\\\', $text);
    $text = str_replace('"', '&quot;', $text);
    $text = str_replace("'", '\\\'', $text);
    return "'$text'";
}

function truncate_string($str,$size)
{
  if (strlen($str)<=$size)
    return ($str);
  return(substr_replace($str,'...',$size-3));
}

function copyIcon($url, $text)
{
    $image = '<img src="images/copy.png" alt="('._("Copy").')" />';
    echo ' '.createLink($url, $image, Array('title' => $text), true);
}

function deleteIcon($url, $text, $confirm_message)
{
    $image = '<img src="images/remove.png" alt="('._("Delete").')" onclick="return confirm('.quote_text($confirm_message).');" />';
    echo ' '.createLink($url, $image, Array('title' => $text), true);
}

function modifiedTimestamp()
{
    return date("Y-m-d");
}

function formSeparator($text, $colspan)
{
    print '<tr><td colspan="'.$colspan.'" class="formsep">'.$text.'</td></tr>';
}

function strip_magic_slashes($value)
{
    if (get_magic_quotes_gpc()) {
        return stripslashes($value);
    } else {
        return $value;
    }
}

?>
